package com.migeran.moe;

import apple.NSObject;
import apple.foundation.NSDictionary;
import apple.foundation.NSURL;
import apple.foundation.NSUserActivity;
import apple.uikit.UIApplication;
import apple.uikit.UIWindow;
import apple.uikit.c.UIKit;
import apple.uikit.protocol.UIApplicationDelegate;

import org.moe.natj.general.Pointer;
import org.moe.natj.general.ann.Owned;
import org.moe.natj.general.ann.RegisterOnStartup;
import org.moe.natj.objc.ann.ObjCBlock;
import org.moe.natj.objc.ann.Selector;

@RegisterOnStartup
public class ApplicationDelegate extends NSObject implements UIApplicationDelegate {

    public static void main(String[] args) {
        UIKit.UIApplicationMain(0, null, null, ApplicationDelegate.class.getName());
    }

    @Owned
    @Selector("alloc")
    public static native ApplicationDelegate alloc();

    protected ApplicationDelegate(Pointer peer) {
        super(peer);
    }

    private UIWindow window;

    @Override
    @Selector("application:didFinishLaunchingWithOptions:")
    public boolean applicationDidFinishLaunchingWithOptions(UIApplication application, NSDictionary<?, ?> launchOptions) {
        System.out.println("Hello");

        return true;
    }

    @Override
    public boolean applicationWillFinishLaunchingWithOptions(UIApplication application, NSDictionary<?, ?> launchOptions) {
        return true;
    }

    @Override
    public void applicationDidBecomeActive(UIApplication application) {
        System.out.println("applicationDidBecomeActive");
    }

    @Override
    public void applicationWillTerminate(UIApplication application) {
        System.out.println("applicationWillTerminate");
    }

    @Selector("application:continueUserActivity:restorationHandler:")
    public boolean applicationContinueUserActivityRestorationHandler(UIApplication application,
                                                                      NSUserActivity userActivity,
                                                                      @ObjCBlock(name = "call_applicationContinueUserActivityRestorationHandler") Block_applicationContinueUserActivityRestorationHandler restorationHandler) {
        window.rootViewController().restoreUserActivityState(userActivity);
        NSURL url = userActivity != null ? userActivity.webpageURL() : null;
        System.out.println("NSURL: " + url);
        return false;
    }

    @Override
    public void setWindow(UIWindow value) {
        window = value;
    }

    @Override
    public UIWindow window() {
        return window;
    }
}
